#include "ehelp.h"
#include "ehelpbook.h"

char *prev_hist[10];
char *next_hist[10];

static bool no_prevpush = false;

void clear_on_exit()
{
	for(int n=0; n<10; n++) {
		if(prev_hist[n]) delete []prev_hist[n];
		if(next_hist[n]) delete []next_hist[n];		
	}
}

void cb_html_link()
{
    if(no_prevpush) {
        return;
    }
    if(((Fl_Simple_Html *)htmlWidget)->prev_filename())
        push_prev(((Fl_Simple_Html *)htmlWidget)->prev_filename());
}


void push_prev(const char *url)
{
    if(!url) return;
    if(prev_hist[0] && !strcmp(url, prev_hist[0])) return;

    if(prev_hist[9]) delete []prev_hist[9];
    int a;
    for(a=9; a>0; a--) {
        prev_hist[a] = prev_hist[a-1];
    }
    prev_hist[0] = strdup(url);

    backButton->activate();
}

char *pop_prev()
{
	char *url = prev_hist[0];
	if(!url) return 0;

	for(int a=1; a<10; a++) {
        prev_hist[a-1] = prev_hist[a];
    }
	prev_hist[9] = 0;

	if(!prev_hist[0]) backButton->deactivate();

	return url;	
}

void push_next(const char *url)
{
    if(!url) return;
    if(next_hist[0] && !strcmp(url, next_hist[0])) return;

    if(next_hist[9]) delete []next_hist[9];
    int a;
    for(a=9; a>0; a--) {
        next_hist[a] = next_hist[a-1];
    }
    next_hist[0] = strdup(url);

    forwardButton->activate();
}

char *pop_next()
{
	char *url = next_hist[0];
	if(!url) return 0;

	for(int a=1; a<10; a++) {
        next_hist[a-1] = next_hist[a];
    }
	next_hist[9] = 0;

	if(!next_hist[0]) forwardButton->deactivate();

	return url;	
}

void init_list()
{
	for(int n=0; n<10; n++) {
		prev_hist[n] = 0;
		next_hist[n] = 0;
	}
}

void open_file() 
{
	char *file_types = _("Help files (*.html), *.{htm|html}, All files (*.*), *");
	const char *f = fl_select_file(0, file_types, _("Open help file"));

	load_file(f);	
}

void load_file(const char *f)
{
    if(f) {
        htmlWidget->load(f);
        helpWindow->label(htmlWidget->title());
    }
}

void previous_url()
{
    char *url = pop_prev();
    if(url) {
        no_prevpush = true;
        push_next(htmlWidget->filename());

        htmlWidget->load(url);
        helpWindow->label(htmlWidget->title());
        delete []url;
        no_prevpush = false;
    }
}

void next_url()
{
    char *url = pop_next();
    if(url) {
        push_prev(htmlWidget->filename());

        htmlWidget->load(url);
        helpWindow->label(htmlWidget->title());
        delete []url;
    }
}

